using System.Runtime.InteropServices;
using System.Text;

namespace TestProject;

/// <summary>
/// 런타임 헬퍼
/// </summary>
public class RuntimeHelper
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Import
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 현재 패키지 전체 명칭 구하기 - GetCurrentPackageFullName(packageFullNameLength, packageFullNameStringBuilder)

    /// <summary>
    /// 현재 패키지 전체 명칭 구하기
    /// </summary>
    /// <param name="packageFullNameLength">패키지 전체 명칭 길이</param>
    /// <param name="packageFullNameStringBuilder">패키지 전체 명칭 문자열 빌더</param>
    /// <returns>처리 결과</returns>
    [DllImport("kernel32", CharSet = CharSet.Unicode, SetLastError = true)]
    private static extern int GetCurrentPackageFullName(ref int packageFullNameLength, StringBuilder packageFullNameStringBuilder);

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region MSIX 여부 - IsMSIX

    /// <summary>
    /// MSIX 여부
    /// </summary>
    /// <remarks>
    /// true  : Package
    /// false : Unpackaged
    /// </remarks>
    public static bool IsMSIX
    {
        get
        {
            var length = 0;

            return GetCurrentPackageFullName(ref length, null) != 15700L;
        }
    }

    #endregion
}